// AtlServ.cpp : Implementation of WinMain


// Note: Proxy/Stub Information
//      To build a separate proxy/stub DLL, 
//      run nmake -f AtlServps.mk in the project directory.

#include "stdafx.h"
#include "resource.h"
#include <initguid.h>
#include "AtlServ.h"
#include "ServiceContext.h"
#include "servicehelper.h"
#include "scmanager.h"

#pragma comment(lib,"Shell32")

class CAtlContext : public CServiceContext
{
public:
	void OnServiceStart()
	{
		HANDLE h_event;
		h_event = CreateEvent(NULL,TRUE,FALSE,NULL);
		h_trd = CreateThread(NULL,0,main_thread,
			h_event,0,&m_maintrd_id);
		WaitForSingleObject(h_event,INFINITE);
		CloseHandle(h_event);
	};

	void OnServiceStop()
	{
		PostThreadMessage(m_maintrd_id,WM_QUIT,0,0);
		WaitForSingleObject(h_trd,INFINITE);
	};

protected:

	static DWORD WINAPI main_thread(PVOID h_event)
	{
		HRESULT hr = CoInitialize(NULL);
	//  If you are running on NT 4.0 or higher you can use the following call
	//  instead to make the EXE free threaded.
	//  This means that calls come in on a random RPC thread
	//  HRESULT hr = CoInitializeEx(NULL, COINIT_MULTITHREADED);

		_ASSERTE(SUCCEEDED(hr));

		// This provides a NULL DACL which will allow access to everyone.
		CSecurityDescriptor sd;
		sd.InitializeFromThreadToken();
		hr = CoInitializeSecurity(sd, -1, NULL, NULL,
			RPC_C_AUTHN_LEVEL_PKT, RPC_C_IMP_LEVEL_IMPERSONATE,
			NULL, EOAC_NONE, NULL);
		
		_ASSERTE(SUCCEEDED(hr));

		hr = _Module.RegisterClassObjects(CLSCTX_LOCAL_SERVER|CLSCTX_REMOTE_SERVER,
			REGCLS_MULTIPLEUSE);
		
		_ASSERTE(SUCCEEDED(hr));
		
		SetEvent((HANDLE)h_event);

		MSG msg;
		while (GetMessage(&msg, 0, 0, 0))
			DispatchMessage(&msg);

		_Module.RevokeClassObjects();

		CoUninitialize();
		
		return 0;
	};

protected:
	DWORD m_maintrd_id;
	HANDLE h_trd;
};

#include "AtlServ_i.c"
#include "InServ.h"

CComModule _Module;

BEGIN_OBJECT_MAP(ObjectMap)
OBJECT_ENTRY(CLSID_CoInServ, CInServ)
END_OBJECT_MAP()

/////////////////////////////////////////////////////////////////////////////
//
extern "C" int WINAPI _tWinMain(HINSTANCE hInstance, 
    HINSTANCE /*hPrevInstance*/, LPTSTR lpCmdLine, int /*nShowCmd*/)
{

#if _WIN32_WINNT >= 0x0400 & defined(_ATL_FREE_THREADED)
    HRESULT hRes = CoInitializeEx(NULL, COINIT_MULTITHREADED);
#else
    HRESULT hRes = CoInitialize(NULL);
#endif
    _ASSERTE(SUCCEEDED(hRes));
    _Module.Init(ObjectMap, hInstance, &LIBID_ATLSERVLib);

	USES_CONVERSION;
	int nArgc;
	LPWSTR* ppArgv = CommandLineToArgvW(T2W(GetCommandLine()),&nArgc);
	if (nArgc < 2){
		CAtlContext actx;
		actx.fInteractWithDesktop = false;
		actx.fOwnProcess = true;			//   
		actx.m_szServiceName = _T("SServ");

		CServiceHelper serv;
		serv.SetServiceCtx(&actx);			//    ServiceMain!
		BOOL fOk = serv.Start();
		return fOk;					//  ,   
	}
	for (int i = 1;i < nArgc;i++)
	{
		if ((ppArgv[i][0] == L'-') || (ppArgv[i][0] == L'/')){
			TCHAR buf[100];

			if (!lstrcmpi(W2T(&ppArgv[i][1]),_T("install"))){
				CSCManager scm;
				if (!scm.Open(SC_MANAGER_CREATE_SERVICE)){	// SCM   
					int err = GetLastError();
					wsprintf(buf,_T("   SCManager\n : %X"),err);
					MessageBox(NULL,buf,_T("Error"),0);
					return 1;
				}
				
				if (!scm.CreateService(_T("SServ"),_T("SimpleService"),
					_T("   1"),false))
				{
					int err = GetLastError();
					wsprintf(buf,_T("    %s\n : %X"),
						_T("SimpleService"),err);
					MessageBox(NULL,buf,_T("Error"),0);
					return 1;
				}
				
				//  
				_Module.RegisterServer(TRUE);

				MessageBox(NULL,_T("  "),_T("OK"),0);
				return 0;
			}
			else if (!lstrcmpi(W2T(&ppArgv[i][1]),_T("remove"))){

				CSCManager scm;
				if (!scm.Open(SC_MANAGER_ALL_ACCESS)){	// SCM   
					int err = GetLastError();
					wsprintf(buf,_T("   SCManager\n : %X"),err);
					MessageBox(NULL,buf,_T("Error"),0);
					return 1;
				}

				if (!scm.DeleteService(_T("SServ"))){
					int err = GetLastError();
					wsprintf(buf,_T("    %s\n : %X"),
						_T("SimpleService"),err);
					MessageBox(NULL,buf,_T("Error"),0);
					return 1;
				}

				//  
				_Module.UnregisterServer(TRUE);

				MessageBox(NULL,_T("  "),_T("OK"),0);
				return 0;
			}
			else if(!lstrcmpi(W2T(&ppArgv[i][1]),_T("RegServer"))){
				_Module.RegisterServer(TRUE);
				return 0;
			}
			else if(!lstrcmpi(W2T(&ppArgv[i][1]),_T("UnregServer"))){
				_Module.UnregisterServer(TRUE);
				return 0;
			}
			else if(!lstrcmpi(W2T(&ppArgv[i][1]),_T("server"))){
				CAtlContext actx;
				actx.fInteractWithDesktop = false;
				actx.fOwnProcess = true;			//   
				actx.m_szServiceName = _T("SServ");
				actx.OnServiceStart();

				//  GUI    
				// 
				MessageBox(NULL,_T("  "),_T(""),0);

				actx.OnServiceStop();
				return 0;
			}
			else{
				MessageBox(NULL,W2T(&ppArgv[i][1]),_T(" "),0);
				return 0;
			}
		}
	}

    _Module.Term();
    CoUninitialize();
    return 0;
}
